/*
Scrivere un programma C che calcoli la funzione "=>" (deriva) su parse tree, data
una grammatica libera (vedi lucidi relativi). Allo scopo, si completi il testo con 
le assunzioni e i vincoli che si ritenga necessari apportare.
 
 ** AUTHOR: Marco Bellia
 ** LPL - Matematica
 ** Pisa 2016
 
Assunzioni.

 (1) Le strutture di albero devono poter avere dimensione arbitraria (nessun limite
	 sul numero di archi e nodi) e sono fornite dal modulo "parseTree.h".
 (2) La grammatica data e' codificata mediante un'opportuna funzione "rules" che dato 
     un Nonterminale ed un indice, i, fornisce la parte destra della i-esima produzione
	 di tale Nonterminale
 
 (3) Strutturiamo in 4 moduli:
		- Deriva.c: contiene la definizione di Deriva
		- ParseTree.c e ParseTree.h: definizioni ed headers dell'implementazione dei
			parse tree e delle liste di parse tree
		- Grammatica.c: contiene rappresentazione della grammatica utilizzata nella
			applicazione
         - main.c: contiene l'applicazione pricipale del programma
*/
#include <stdlib.h>
#include "parseTree.h"
#include "Grammatica.c"

bool Deriva(parseTree tree, int index){
    //index=1 for the first alternative
    if (isEmpty(tree)||(isLeaf(tree)&&(tree->labelKind==1))) return false;
    if (isLeaf(tree)){
        return(rules(index,tree));
    }
    {//scan the sons
        treeList sons = tree->sons;
        bool flag = false;
        parseTree first;
        treeList others;
        while(split(sons,&first,&others)&&!flag){
            flag = Deriva(first,index);
            sons = others;
        }
        return flag;
    }
}

