/*
parseTree.h e' un modulo che fornisce l'implementazione di 3 nuovi tipi di dato
e la specifica delle operazioni appliabili. Questi tipi sono:
Il tipo parseTree con le seguenti operazioni (di interfaccia):
 - makeEmpty
 - makeLeaf
 - makeRooted
 - isEmpty
 - isLeaf
 - isRooted
 - getLabel
 - getSons
 - printlnTree
 Il tipo treeList con le seguenti operazioni (di interfaccia)
 - nil
 - cons
 - split
 Il tipo bool senza operazioni con due valori literal
 + false
 + true
 
 ** AUTHOR: Marco Bellia
 ** LPL - Matematica
 ** Pisa 2016
 
 */
 
//Strutture per rappresentare alberi parseTree
typedef enum{NT,T} tLabel;
typedef enum{leaf,rooted} tNode;

struct parseTreeStruct{
    tNode treeKind; //0=leaf; 1=rooted; pointer null per emptyTree.
    char * etichetta;
    tLabel labelKind; //0=NonTerminale; 1=Terminale.
    struct treeListStruct * sons;
};
struct treeListStruct{
    struct parseTreeStruct * currentSon;
    struct treeListStruct * next;
};

//Tipi per alberi, liste di alberi, booleani
typedef struct parseTreeStruct * parseTree;
typedef struct treeListStruct * treeList;
typedef enum{false,true} bool;

//Le operazioni di parseTree
parseTree makeEmpty();
parseTree makeLeaf(tLabel labelKind, char * etichetta);
parseTree makeRooted(char * etichetta, treeList sons);
//Le operazioni: Ispettori e Selettori di parseTree
bool isEmpty(parseTree t);
bool isLeaf(parseTree t);
bool isRooted(parseTree t);
bool getLabel(parseTree t, char** r);
treeList getSons(parseTree t);
//-- operazioni per la stampa --
void printlnTree(parseTree t);

//Le operazioni: Costruttori di treeList
treeList nil();
treeList cons(parseTree val, treeList list);
//Le operazioni: Ispettori e Selettori di treeList
bool split(treeList list, parseTree * treeVal, treeList * listVal);

